#ifndef __YDKmenu_h__
#define __YDKmenu_h__

#define TEST_PEN_MENU(x,y,rect) \
(x>rect.topLeft.x)&&(x<rect.topLeft.x+rect.extent.x)&&(y>rect.topLeft.y)&&(y<rect.topLeft.y+rect.extent.y)

int menu_confirm(char *message);
int menu_confirm2(char *message);
int menu_debug(char *message);
void menu_message(char *message);
void menu_messageL(char *message);
void menu_messageRaw(int X,int Y,char *message);
void menu_button (int X,int Y,char *message,int state,RectanglePtr area,int size);
void menu_bar(int X,int Y,int val,int max,RectangleType *area);
int menu_waitPen(int *X, int *Y, int wait_release, int button_too);
void menu_info(char *message);

int menu_getTick(void);
void menu_wait(int ms);

uint8 *ljp_WinScreenLock(int mode);
void ljp_WinScreenUnlock(void);
/*********************************************************/
/* STANDARD GUI STUFF */
/*********************************************************/

#define GUI_REDRAW_BG {	\
  	  	if (redraw) {\
		scr=/*(uint8*)(g_pnobridge -> vram);*/ljp_WinScreenLock(0); \
		if (savescr) {\
	    	uint8 *tmpdst;\
			uint8 *tmpsrc=savescr;\
			if (scr) tmpdst=scr;\
			else tmpdst=(uint8*)(g_pnobridge -> vram);\
			for (int yy=0;yy<display_height;yy++)\
		  	{\
			    memcpy(tmpdst,tmpsrc,display_width*2);\
		    	tmpsrc+=display_width*2;\
			    tmpdst+=display_pitch*2;\
			}\
		}\
		else {\
			if (scr) memset(scr,0,display_width*display_height*2);\
			else memset((uint8*)(g_pnobridge -> vram),0,display_width*display_height*2);\
		}\
		RGBColorType fg;\
	  	WinPushDrawState ();\
  	  	WinSetDrawMode(winOverlay);\
    	fg.r=50;fg.g=200;fg.b=50;\
	    WinSetTextColorRGB(&fg,NULL);\
	    WinSetForeColorRGB(&fg,NULL);\
	    FntSetFont(boldFont);\
		WinPaintChars(LJP_OSD_TITLE,strlen(LJP_OSD_TITLE),10,10);	\
		WinPopDrawState();\
		}\
		redraw=0;}

#endif

